import processing.core.*; 
import processing.xml.*; 

import procontroll.*; 
import net.java.games.input.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class OSBprotoNo7 extends PApplet {





int pxS=3;//pixel size;
Dpixel[][] px;
int currentForeground=1;
float seqMotif=0;
PImage level;
boolean[] lifeLine;
int[] depot;
int depotSize=10;
int depotFall=0;
boolean punkMode = false;// TODO set this true
int lowlandCount=0;
int titleScreenCount=0;
float fallSpeed=1;
int nbPlays=0;

ControllIO controllIO;
ControllDevice[] joypad;

public void setup() {

  controllIO = ControllIO.getInstance(this);
  joypad = new ControllDevice[controllIO.getNumberOfDevices()];

  for (int i =0;i<joypad.length;i++) {
    joypad[i] = controllIO.getDevice(i);
    joypad[i].plug(this, "handleButton1Press", ControllIO.ON_PRESS, 1);
    joypad[i].plug(this, "handleButton1Press", ControllIO.ON_PRESS, 0);
  }

  level=loadImage("level1.png");  
  px = new Dpixel[level.width][level.height];
  lifeLine = new boolean[level.width];
  depot = new int[level.width];
  for (int i=0;i<depot.length;i++) {
    lifeLine[i]=true;
    depot[i]=ceil((float)depotSize/2);
  }
  size(level.width*pxS,level.height*pxS+depotSize*pxS);
  colorMode(HSB);
  frameRate(40);

  for (int x=0;x<level.width;x++) {
    for (int y=0;y<level.height;y++) {
      if (red(level.get(x,y))==0xFF) {
        px[x][y]=new Dpixel(x,y,1);
      }
      else if (green(level.get(x,y))==0xFF) {
        px[x][y]=new Dpixel(x,y,2);
      }
      else if (blue(level.get(x,y))==0xFF) {
        px[x][y]=new Dpixel(x,y,3);
      }      
      else{
        px[x][y]=new Dpixel(x,y,0);
      }
    }
  }

  noSmooth();
  noStroke();

}

public void draw() {
  if (titleScreenCount!=0) {// when you loose or win
    if (abs(titleScreenCount)==100) {
      nbPlays++;
      if (nbPlays%3==0) {
        punkMode=true;
      }
      else{
        punkMode=false;
      }
      for (int i=0;i<depot.length;i++) {
        lifeLine[i]=true;
        depot[i]=ceil((float)depotSize/2);
      }
      for (int x=0;x<level.width;x++) {
        for (int y=0;y<level.height;y++) {
          if (red(level.get(x,y))==0xFF) {
            px[x][y]=new Dpixel(x,y,1);
          }
          else if (green(level.get(x,y))==0xFF) {
            px[x][y]=new Dpixel(x,y,2);
          }
          else if (blue(level.get(x,y))==0xFF) {
            px[x][y]=new Dpixel(x,y,3);
          }      
          else{
            px[x][y]=new Dpixel(x,y,0);
          }
        }
      }
      fallSpeed=1;
    }
    if (titleScreenCount<0) {
      titleScreenCount++;
      fill(0x00,0xFF,0xFF);
      rect(random(width)-(width/2),random(height)-(height/2),random(width),random(height));
    }
    else{
      titleScreenCount--;
      fill(0xAA,0xFF,0xFF);
      rect(random(width)-(width/2),random(height)-(height/2),random(width),random(height));
    }
  }
  else{
    if (random(100)<6) {//creates a new white block somewhere
      float divi=5;
      int startX=(int)random(level.width-(level.width/divi));
      int startY=(int)(random(level.height-(level.height*2/divi))+(level.height/divi));
      int endX=startX+(int)random(level.width/divi);
      int endY=startY+(int)random(level.height/divi);
      int type=floor(random(2))+1;
      int margin = floor(random(20)+5);
      for (int x=startX;x<endX;x++) {
        for (int y=startY;y<endY;y++) {
          if (y<startY+margin || y>endY-margin) {
            px[x][y].type=0;
          }
          else{
            px[x][y].type=type;
          }
        }
      }
    }
    background(0);
    fill(0xFF);  
    seqMotif=seqMotif%0xFFFF;
    for (int y=0;y<level.height;y++) {  
      for (int x=0;x<level.width;x++) {
        if (!punkMode) {
          px[x][y].displaySoft();
        }
        else{
          px[x][y].displayPunk();
        }
      }
    } 
    fill(0xAA,0x55,0x55);
    rect(0*pxS,height-depotSize*pxS,level.width*pxS,1*pxS);  
    for (int i=0;i<lifeLine.length;i++) {//draw the falling blue line
      if (lifeLine[i]) {
        fill(0xAA,0xFF,0xFF);
        rect(i*pxS,depotFall*pxS,pxS,pxS);
      }
    }
    fill(0xAA,0xFF,0xFF);  
    for (int i=0;i<depot.length;i++) {//draw the blue thing at the bottom of the screen
      rect(i*pxS,height-depot[i]*pxS,pxS,depot[i]*pxS);
    }
    boolean noLife=true;//that's when you play too much online games
    for (int i=0;i<depot.length;i++) {
      if (lifeLine[i]) noLife=false;
    }
    int totalLife=0;
    for (int i=0;i<depot.length;i++) {
      totalLife+=depot[i];
    }
    boolean touchDepot=false;
    for (int i=0;i<depot.length;i++) {
      if (lifeLine[i]) {
        if (depot[i]>depotSize-(depotFall-level.height)) {
          touchDepot=true;
        }
      }
    }    
    for (int fallCount=0;fallCount<floor(fallSpeed);fallCount++) {//make the blue thing fall
      depotFall++;
      if (depotFall >= level.height+depotSize || noLife || touchDepot) {
        fallCount=ceil(fallSpeed);
        int startLife=(int)(random(level.width/2));
        int endLife=(int)max(startLife+random(level.width/2),startLife+30);
        fallSpeed=min(fallSpeed+0.15f,2);
        if (totalLife<(depot.length*(depotSize/4))) {
          lowlandCount=(lowlandCount+1)%1;
        }
        else if (totalLife<(depot.length*(depotSize/3))) {
          lowlandCount=(lowlandCount+1)%3;          
        }
        else if (totalLife<(depot.length*(depotSize/2))) {
          lowlandCount=(lowlandCount+1)%4;          
        }
        else {
          lowlandCount=(lowlandCount+1)%5;
        }
        for (int i=0;i<depot.length;i++) {
          if (lifeLine[i]) {
            depot[i]++;
          }
          if (lowlandCount==0) { 
            depot[i]--;
          }
          if (i>=startLife && i <endLife) {
            lifeLine[i]=true;
          }
          else{
            lifeLine[i]=false;
          }
        }
        depotFall=0;
      }
      if (depotFall<level.height) {
        for (int i=0;i<lifeLine.length;i++) {
          if (lifeLine[i]) {
            if (px[i][depotFall].type==currentForeground || px[i][depotFall].type==3) {
              lifeLine[i]=false;
              px[i][depotFall].type=0;
              fill(0x00,0xFF,0xFF);
              rect(i*pxS,(depotFall-ceil(random(5)))*pxS,pxS,pxS);
            }
          }
        }
      }
    }   
    boolean perdu=true;
    for (int i=0;i<depot.length;i++) {
      if (depot[i]>0) perdu=false;
      if (depot[i]>=depotSize) titleScreenCount=100;
    }
    if (perdu) titleScreenCount=-100;
  }
  for (int i=2;i<depot.length-2;i++) {
    if (depot[i]-depot[i-1]>=2){
      depot[i]--;
      depot[i-1]++;  
    }
    if (depot[i]-depot[i-1]<=-2){
      depot[i]++;
      depot[i-1]--;  
    }
    if (depot[i]-depot[i-2]>=2){
      depot[i]--;
      depot[i-2]++;  
    }
    if (depot[i]-depot[i-2]<=-2){
      depot[i]++;
      depot[i-2]--;  
    }    
  }
}

class Dpixel {
  int x;
  int y;

  int type;// 0=empty 1=plan1 2=plan2 3=plan1+2

  Dpixel(int x, int y, int type) {
    this.x=x*pxS;
    this.y=y*pxS;
    this.type=type;
  }

  public void displayPunk() {
    fill(0xFF);
    if (type!=0) {
      seqMotif+=0.1f;
      if (type==1 || type==2) {
        if (type==currentForeground) {
          if (seqMotif%7<5) rect(x,y,pxS,pxS);
        }
        else{
          if (seqMotif%73<10) rect(x,y,pxS,pxS);
        }
      }
      if (type==3) {  
        if (seqMotif%100<99) rect(x,y,pxS,pxS);
      }
    }
  }

  public void displaySoft() {
    if (type!=0) {
      if (type==1 || type==2) {
        if (type==currentForeground) {
          fill(0xEE);
          rect(x,y,pxS,pxS);
        }
        else{
          fill(0x11);          
          rect(x,y,pxS,pxS);
        }
      }
      if (type==3) {
        fill(0xFF);
        rect(x,y,pxS,pxS);
      }
    }
  }

}

public void keyPressed() {
  currentForeground=(currentForeground%2)+1;
}

public void handleButton1Press(){
  currentForeground=(currentForeground%2)+1;
}










































  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--hide-stop", "OSBprotoNo7" });
  }
}
